path "..\\template";

include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;
include <particle.wdl>;

BMAP firemap2 = <green1.bmp>;
BMAP blood_map = <blood.pcx>;
BMAP title_map = <title.pcx>;
BMAP win_map = <win.pcx>;
BMAP defeat_map = <defeat.pcx>;
BMAP hp_map = <hp.pcx>;
BMAP face_map1 = <bang_face.pcx>;
BMAP face_map2 = <knight_face.pcx>;
BMAP help_map = <help.pcx>;

sound shoot_bang = <bang.wav>;
sound sword = <wind.wav>;
sound heeling = <heel.wav>;
sound hat = <hat.wav>;
sound boom = <boom.wav>;

//Starting Engine Values
var video_mode=7;
var video_depth=16;
var fps_max=50;
var midi;

synonym left { type entity; }
synonym right { type entity; }
synonym water_ball { type entity; }
synonym effect_light { type entity; }
synonym effect_blood1 { type entity; }
synonym effect_blood2 { type entity; }

var right_action_state;
var left_action_state;
var right_recover=10;
var left_recover=10;
var game_over=0;
var water=0;
var heel_left=0;
var heel_right=0;
var heel_shoot=0;
var can_shoot=1;
var game_start=0;
var normal_state=1;
var nleft_hp;
var nright_hp;


panel title
{
	bmap = title_map;
	pos_X = 0; pos_y = 0;
	flags = REFRESH,VISIBLE;
}

panel help_screen
{
	bmap = help_map;
	pos_X = 0; pos_y = 0;
	flags = REFRESH,OVERLAY;
}

panel win
{
	bmap = win_map;
	pos_X = 0; pos_y = 0;
	flags = REFRESH,OVERLAY;
}

panel defeat
{
	bmap = defeat_map;
	pos_X = 0; pos_y = 0;
	flags = REFRESH,OVERLAY;
}

panel left_hp
{
	pos_x = 480;
	pos_y = 560;
	layer	= 1;
	hbar = 0,0,300,hp_map,60,nleft_hp;
	flags = d3d,refresh;
}

panel right_hp
{
	pos_x = 80;
	pos_y = 560;
	layer	= 1;
	hbar = 0,0,300,hp_map,60,nright_hp;
	flags = d3d,refresh;
}

panel left_face
{
	bmap = face_map2;
	pos_X = 420; pos_y = 520;
	flags = REFRESH,OVERLAY;
}

panel right_face
{
	bmap = face_map1;
	pos_X = 20; pos_y = 520;
	flags = REFRESH,OVERLAY;
}

action player_right
{
	right = my;
	my.pan=90;
	if(my.shadow == off){ drop_shadow(); }
	while ((right == null) || (left == null)){ wait(1); }
}

action player_left
{
	left = my;
	my.pan=90;
	if(my.shadow == off){ drop_shadow(); }
	while ((right == null) || (left == null)){ wait(1); }
}

action water_ball_action
{
	water_ball = my;	
	if(my.shadow == off){ drop_shadow(); }
}

action light_action
{
	effect_light = my;
}

action blood1_action
{
	effect_blood1 = my;
}

action blood2_action
{
	effect_blood2 = my;
}

// Ȱ ڱġ
function vec_fire(&vec)
{
	vec[0] = random(30) - 15;
	vec[1] = random(30) - 15;
	vec[2] = random(10) - (abs(my.vel_x) + abs(my.vel_y)) * 0.3 + random(5);
}

function fire_func()
{
	my.vel_x = my.vel_x * 0.5;
	my.vel_y = my.vel_y * 0.5;
	my.alpha -= time * 2;
	if(my.alpha < 0) { my.lifespan = 0; }
	my.bmap = firemap2;
}

function particle_fire()
{
	vec_fire(temp);
	vec_set(my.vel_x,temp);
	my.lifespan = 15;
	my.flare = on;	//flare transparency
	my.bright = on;	//glowing effect
	my.move = on;	//move according to vel_x, vel_y, and vel_z
	my.streak = on;	//new streak effect
	my.bmap = firemap2;
	my.alpha = 20;
	my.size = 10;
	my.function = fire_func;	//no mid-life mods yet!
}

// Ƣ
function fade_func()
{
	my.alpha -= my.skill_x * time;
	if(my.alpha < 0) { my.lifespan = 0; }
}

function fade_particle()
{
	my.alpha -= 5 * time;
	if (my.alpha < 0) {my.lifespan = 0;}
}

function particle_blood()
{
	temp.x = random(2) - 1;
	temp.y = random(2) - 1;
	temp.z = random(1) - 1.5;
	vec_add (my.vel_x, temp);
	my.alpha = 70 + random(30);
	my.bmap = blood_map;
	my.size = 100;
	my.flare = on;	
	my.bright = on;
	my.move = on;
	my.lifespan = 20;
	my.function = fade_particle;
}

function pos_camera()
{
	camera.y = ((right.y + left.y)/2);
	camera.x = -((right.y - left.y)+800);
	wait(1);
}

string s;
string s2;

function hit()
{
	play_sound(boom,100);
	effect_blood2.x = right.x-40;
	effect_blood2.y = right.y;
	effect_blood2.z = right.z+60;
	effect_blood2.skill20 = 0; // reset "attack" frames
	while (effect_blood2.skill20 < 100)
	{
		effect (particle_blood, 2, effect_blood2.x, normal);

		ent_cycle("attack", effect_blood2.skill20); // play attack frames animation
		effect_blood2.skill20 += 5 * time; // "attack" animation speed
	}

	right.y += 20;
	if(right.y>2700)
	{
		right.y=2700;
	}
	right_recover+=1;
	if(right.skin<5)
	{
		right.skin+=1;
	}
	else
	{
		right_action_state=3;
		game_over=1;
		right.frame=34;
		media_stop(midi);
		midi = media_loop("win.mid", null, 100);
	}
}

function damage()
{
	play_sound(boom,100);
	effect_blood1.x = left.x-40;
	effect_blood1.y = left.y-10;
	effect_blood1.z = left.z-20;
	effect_blood1.skill20 = 0; // reset "attack" frames
	while (effect_blood1.skill20 < 100)
	{
		effect (particle_blood, 2, effect_blood1.x, normal);

		ent_cycle("attack", effect_blood1.skill20); // play attack frames animation
		effect_blood1.skill20 += 5 * time; // "attack" animation speed
	}
	
	left.y -= 20;
	if(left.y<-2600)
	{
		left.y=-2600;
	}
	left_recover+=1;
	if(left.skin<5)
	{
		left.skin+=1;
	}
	else
	{
		left_action_state=3;
		game_over=-1;
		media_stop(midi);
		midi = media_loop("defeat.mid", null, 100);
		left.frame=60;
	}
}

function game()
{
	while(game_start == 0)
	{
		camera.pan+=1;
		if(key_space == 1)
		{
			game_start = 1;
			camera.pan=0;
			help_screen.visible = off;
			left_hp.visible = on;
			right_hp.visible = on;
			left_face.visible = on;
			right_face.visible = on;
			media_stop(midi);
			midi = media_loop("battle.mid", null, 100);
		}
		wait(1);
	}
	while(game_start == 1)
	{
		//ü
		if(left_action_state == 3){nleft_hp = 0;}
			else {nleft_hp = 6 - left.skin;}
		if(right_action_state == 3){nright_hp = 0;}
			else {nright_hp = 6 - right.skin;}
		//  
		if(game_over!=0)
		{
			goto death;
		}
		pos_camera();
		//
		if(left_action_state==0 && key_z) //
		{
			play_sound(hat,100);
			left_action_state=1;
			left.frame=41;
			goto bang;
		}
		if(left_action_state==0 && key_x) //
		{
			play_sound(sword,100);
			left_action_state=2;
			left.frame=52;
			goto bang;
		}
		//̵
		if(key_cul==1)
		{
			if(normal_state==1)
			{
				left.y+=5;
				if(left.y+110 > right.y)
				{
					left.y = right.y-110;
				}
			}
			else
			{
				left.y-=5;
				if(left.y<-2600)
				{
					left.y = -2600;
				}
			}
			if(left_action_state==0)
			{
				left.frame+=1;
			}
			goto bang;
		}
		if(key_cur==1)
		{
			if(normal_state==1)
			{
				left.y-=5;
				if(left.y<-2600)
				{
					left.y = -2600;
				}
			}
			else
			{
				left.y+=5;
				if(left.y+110 > right.y)
				{
					left.y = right.y-110;
				}
			}
			if(left_action_state==0)
			{
				left.frame+=1;
			}
			goto bang;
		}

		bang:
		//氥 AI
		if(right_action_state==0 && right.y - left.y < 200) //ħ
		{
			right_action_state=2;
			play_sound(sword,100);
			right.frame=20;
		}
		if(right_action_state==0 && water==0 && can_shoot>=1)	//߻
		{
			water=-10+(-3*right.skin);
			can_shoot=0;
			right.frame=20;
			right_action_state=1;
		}
		if(right_action_state==0 && right.y - left.y < 250 && right.y<2700) //
		{
			right.y+=5;
			right.frame+=1;
		}
		if(right_action_state==0 && right.y - left.y > 600) //߰
		{
			right.y-=5;
			right.frame+=1;
		}
		//氥 ൿ
		if(right_action_state==0) //ȱ
		{
			right.frame+=time;
			if(right.frame>=20)
			{			
				right.frame=0;
			}
		}
		if(right_action_state==1) //߻
		{
			right.frame+=time/2;
			if(right.frame>=27)
			{
				play_sound(shoot_bang,100);
				water_ball.x = right.x;
				water_ball.y = right.y-120;
				water_ball.z = right.z+70;
				effect_light.x = right.x;
				effect_light.y = right.y-100;
				effect_light.z = right.z+70;
				effect(particle_fire,1000,effect_light.x,normal);
				right_action_state=0;
				right.frame=5;
			}
		}
		if(right_action_state==2) //ħ
		{
			right.frame+=time;
			if(right.frame>=34)
			{
				if(left.y+150 > right.y)
				{
					damage();
					normal_state = normal_state * -1;
				}
				right_action_state=0;
				right.frame=5;
			}
		}
		if(water!=0 && right_action_state!=1)	// 
		{
			// ư 
			if(water < 0)
			{
				if(water_ball.y - 50 > left.y)
				{
					water_ball.y+=water;
				}
				else
				{
					if(left_action_state == 2 && left.frame>=56)
					{
						water=water*-1;
					}
					else
					{
						damage();
						water_ball.z=-200;
						water=0;
					}
				}
			}
			else	//氥  ư 
			{
				if(water_ball.y + 100 < right.y)
				{
					water_ball.y+=water;
				}
				else
				{
					hit();
					water_ball.z=-200;
					water=0;
				}
			}
		}


		// ൿ
		if(left_action_state==0) //ȱ
		{
			left.frame+=0.6 * time;
			if(left.frame>=40)
			{
				left.frame=0;
			}
		}
		if(left_action_state==1) //
		{
			left.frame+=time;
			if(left.frame>=52)
			{
				if(left.y+150 > right.y)
				{
					hit();
				}
				if(left_action_state != 3)
				{
					left_action_state=0;
				}
				left.frame=11;
			}
		}
		if(left_action_state==2) //޾ġ
		{
			left.frame+=time;
			if(left.frame>=60)
			{
				if(left_action_state != 3)
				{
					left_action_state=0;
				}
				left.frame=11;
			}
		}

		//氥 ջ ȸ
		if(right.skin>1)
		{
			heel_right+=time;
			if(heel_right>=right_recover)
			{
				heel_right=0;
				right.skin -= 1;
			}
		}
		// ջ ȸ
		if(left.skin>1)
		{
			heel_left+=time;
			if(heel_left>=left_recover)
			{
				heel_left=0;
				left.skin -= 1;
			}
		}
		// ȸ
		heel_shoot+=time;
		if(heel_shoot >= 70-(right.skin*10))
		{
			heel_shoot=0;
			can_shoot += 1;
		}

		death:
		if(left_action_state==3) // 
		{
			if(left.z>0) //ɱ
			{
				left.z-=time/2;
			}
			if(camera.x<left.x-200)
			{
				camera.x+=1;
			}
			if(camera.y>left.y+20)
			{
				camera.y-=1;
			}
			if(left.frame<=70)
			{
				left.frame+=time/10;
			}
			else
			{
				defeat.visible=on;
			}
		}
		if(right_action_state==3) //氥 
		{
			if(camera.x<right.x-200)
			{
				camera.x+=1;
			}
			if(camera.y<right.y-50)
			{
				camera.y+=1;
			}
			if(right.frame<=43)
			{
				right.frame+=time/10;
				if(right.y<2700) //
				{
					right.y+=time;
				}
			}
			else
			{
				win.visible=on;
			}
		}

		/*if(left.frame==0)
		{

			str_for_num(s,can_shoot);
			//str_for_num(s2,water_ball.y);
			//str_cat(s," ");
			//str_cat(s,s2);
			msg.string = s;
			show_message();
		}*/
		wait(1);
	}
}

function main()
{
	fps_max=50;
	warn_level=2;
	tex_share=on;

	midi = media_loop("begin.mid", null, 100);
	load_level (<GRIBORO.wmb>);
	waitt(30);
	title.visible=off;
	help_screen.visible=on;

	load_status();

	camera.pan = 0;
	camera.x=-380;
	camera.y=-40;
	camera.z=70;

	game();
}